using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Molly_the_Were_Zompire_RPG
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        TextBox myTextBox = new TextBox();
        Menu myMenu = new Menu();
        Menu charMenu = new Menu();
        Character[] myChar = new Character[5];
        sys mySys = new sys();
        quest myquest = new quest();
        //Save/Load Stuff
        IAsyncResult IAResult;
        Object stateobj;
        int GameSaveRequested = 0;  //0 = not requested, 1 = requested but haven't selected device, 2 = select device
        //myChar = new Character[5];
        //Character myChar = new Character();
        //int startup = 0; //startup = 0, otherwise, not start = 1
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            graphics.PreparingDeviceSettings +=
            new EventHandler<PreparingDeviceSettingsEventArgs>(
            graphics_PreparingDeviceSettings);
            this.Components.Add(new GamerServicesComponent(this));
        }

        void graphics_PreparingDeviceSettings(object sender, PreparingDeviceSettingsEventArgs e)
        {
            foreach (Microsoft.Xna.Framework.Graphics.DisplayMode displayMode in GraphicsAdapter.DefaultAdapter.SupportedDisplayModes)
            {
                // If 1080i (Widescreen) format is available, set it to use this format.
                // 1080i is 19201080, so check to see if there is a DisplayMode available 
                // that matches.
                if (displayMode.Width == 1280 && displayMode.Height == 720)
                {
                    e.GraphicsDeviceInformation.PresentationParameters.BackBufferFormat = displayMode.Format;
                    e.GraphicsDeviceInformation.PresentationParameters.BackBufferHeight = displayMode.Height;
                    e.GraphicsDeviceInformation.PresentationParameters.BackBufferWidth = displayMode.Width;
                    e.GraphicsDeviceInformation.PresentationParameters.FullScreenRefreshRateInHz = displayMode.RefreshRate;
                    e.GraphicsDeviceInformation.PresentationParameters.IsFullScreen = true;
                }
            }
        }
        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        public void MyIntialize()
        {
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
            MyIntialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        SpriteFont font;
        public Texture2D SpriteBlue;
        public Texture2D SpriteBlack;
        public Texture2D Sprite900x400Box;
        public Texture2D Sprite150x110Box;
        public Texture2D SpriteTextBoxImage;
        public Texture2D SpriteCharBoxImage;
        public Texture2D SpriteTitleImage;
        public Texture2D SpriteMenuBoxImage;
        public Texture2D SpriteMenuSelectSImage;
        //public Texture2D SpriteBackground;  Add later
        //public Texture2D SpriteRightArrow;
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            font = Content.Load<SpriteFont>("Kootenay");
            SpriteBlue = Content.Load<Texture2D>("LBPNG");
            SpriteBlack = Content.Load<Texture2D>("BlackPNG");
            Sprite900x400Box = Content.Load<Texture2D>("900x400Box");
            Sprite150x110Box = Content.Load<Texture2D>("150x110Box");
            SpriteTextBoxImage = Content.Load<Texture2D>("TextBoxImage");
            SpriteCharBoxImage = Content.Load<Texture2D>("CharBoxImage");
            SpriteTitleImage = Content.Load<Texture2D>("TitleImage");
            SpriteMenuBoxImage = Content.Load<Texture2D>("MenuBoxImage");
            SpriteMenuSelectSImage = Content.Load<Texture2D>("MenuSelectSImage");
            //SpriteBackground = Content.Load<Texture2D>("Background");
            //SpriteRightArrow = Content.Load<Texture2D>("RightArrow");
            //TextBox[] myTextBox = new TextBox[10];
            // TODO: use this.Content to load your game content here
        }
        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            if ((!Guide.IsVisible) && (GameSaveRequested == 1))
            {
                GameSaveRequested = 2;
                IAResult = Guide.BeginShowStorageDeviceSelector(PlayerIndex.One, null, null);
            }
            if ((GameSaveRequested == 2) && (IAResult.IsCompleted))
            {
                StorageDevice device = Guide.EndShowStorageDeviceSelector(IAResult);
                if (device.IsConnected)
                {
                    DoSaveGame(device);
                }
                // Reset the request flag
                GameSaveRequested = 0;
            }

            UpdateInfo();
            // TODO: Add your update logic here

            base.Update(gameTime);
        }  //Control + general game functions in here

        void DoSaveGame(StorageDevice device)
        {
            //
        }


        GamePadState previousGamePadState; int justStarting = 0;
        //TextBox[] myTextBox = new TextBox[10];

        GamePadState currentState;
        string myButton;
        void UpdateInfo()
        {
            if (justStarting == 0)
            {
                for (int x = 0; x < 5; x++)
                {
                    myChar[x] = new Character();
                    //myChar[x].letsTest(); //lets set everyone for testing
                }
                //myChar[0].letsTest();
                myChar[0].InitiateChar("Molly", 0, 1, 1, 1);
                myChar[1].InitiateChar("Molly", 10, 2, 2, 2);
                myChar[2].InitiateChar("Molly", 100, 5, 1, 1);
                myChar[3].InitiateChar("Molly", 1000, 1, 5, 1);
                myChar[4].InitiateChar("Molly", 10000, 1, 1, 5);
                TextSet(0, 0);
                myMenu.Determine(0, 0);
                mySys.mode = 0;
                justStarting = 1;
            }
            // Get the current gamepad state.
            currentState = GamePad.GetState(PlayerIndex.One);
            if (currentState.IsConnected)
            {
                myButton = "";
                if (currentState.Buttons.A == ButtonState.Pressed &&
                    previousGamePadState.Buttons.A == ButtonState.Released)
                {
                    // Button A has just been pressed; add vibration.
                    myButton = "A";
                }
                if (currentState.Buttons.B == ButtonState.Pressed &&
                    previousGamePadState.Buttons.B == ButtonState.Released)
                {
                    // Button A has just been pressed; add vibration.
                    myButton = "B";
                }

                if (currentState.Buttons.X == ButtonState.Pressed &&
                    previousGamePadState.Buttons.X == ButtonState.Released)
                {
                    // Button A has just been pressed; add vibration.
                    myButton = "X";
                }
                if (currentState.Buttons.Y == ButtonState.Pressed & previousGamePadState.Buttons.Y == ButtonState.Released)
                {
                    myButton = "Y";
                }
                if (currentState.DPad.Up == ButtonState.Pressed &&
                        previousGamePadState.DPad.Up == ButtonState.Released)
                {
                    myButton = "Up";
                }
                if (currentState.DPad.Down == ButtonState.Pressed &&
                    previousGamePadState.DPad.Down == ButtonState.Released)
                {
                    myButton = "Down";
                }
                if (currentState.DPad.Right == ButtonState.Pressed &&
                    previousGamePadState.DPad.Right == ButtonState.Released)
                {
                    myButton = "Right";
                }
                if (currentState.DPad.Left == ButtonState.Pressed &&
                    previousGamePadState.DPad.Left == ButtonState.Released)
                {
                    myButton = "Left";
                }

                //test myTextBox.pressA = 0;
                //if (myTextBox.line[myTextBox.startLine + myTextBox.maxLines] != "")
                //    myTextBox.pressA = 1;

                if (myButton != "")
                {
                    if (myTextBox.pressA == 0 && mySys.pressA == 0)  //&& mySys.pressA == 0
                    {
                        myMenu.MenuControl(myButton);
                    }
                    else
                    {
                        if (myButton == "A")
                        {
                            myMenu.myChoice = "";
                            if (myTextBox.pressA == 0)
                            {
                                mySys.pressA = 0;
                            }
                            else
                            {
                                myTextBox.startLine = myTextBox.startLine + myTextBox.maxLines;
                                if (myTextBox.line[myTextBox.startLine + myTextBox.maxLines] == "")
                                {
                                    myTextBox.pressA = 0;
                                }
                            }
                        }
                    }
                }
                if (myButton == "Y" & mySys.buttonY == 1)
                {
                    mySys.mode = 2;
                }
                if (myTextBox.pressA == 0)
                {
                    Flow();
                }
                // Update previous gamepad state.
                previousGamePadState = currentState;
                //lastButton = myButton;
            }
        }  //Control + general game functions in here #2

        void Flow()
        {
            int previousMode = mySys.mode;
            switch (mySys.mode)
            {
                case 0: switch (myMenu.myChoice) //Title Screen
                {
                    case "Start": mySys.mode = 1; //TextSet(0, 1);
                        break;
                    case "Continue": TextSet(0, 2);
                        break;
                    case "Cancel": TextSet(0, 0);
                        break;
                    case "Analyze": TextSet(0, 3); //test
                        mySys.pressA = 1;
                        break;
                    case "Quit": this.Exit();
                        break;
                }
                break;
            case 1:switch (myMenu.myChoice)  //Mode Select Screen
                {
                    case "Exit": mySys.mode = 0;
                        break;
                }
                break;
                case 2: break;  //Character Menu
                default: break;
            }
            if (mySys.mode != previousMode)
            {
                mySys.buttonY = 0;
                switch (mySys.mode)
                {
                    case 0: TextSet(0, 0);
                        myMenu.Determine(0,0);
                        break;
                    case 1: myMenu.Determine(1,0); //temp
                        mySys.buttonY = 1;

                        break;
                    default: break;
                }
            }
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            //graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            //if (letsUpdate == 1)
            //{
            spriteBatch.Begin();
            graphics.GraphicsDevice.Clear(Color.White);
            //spriteBatch.Draw(SpriteBackground, new Vector2(0,0), Color.White);
            DrawTextBox();
            DrawQuickStats();
            DrawMenu();
            spriteBatch.End();
            base.Draw(gameTime);
            //}
        }  //All drawing done from here

        public void DrawQuickStats()
        {
            Vector2 pos = new Vector2(1050, 0);
            string theText;
            Vector2 resultLength;
            int x1;
            // spriteBatch.Draw(SpriteRightArrow, new Vector2(1030,500), Color.White);
            for (int x = 0; x < 5; x++)
            {
                if (myChar[x].name != "") //if member is there, remember to fix 
                {
                    pos.Y = 45 + (x * 130); //45
                    spriteBatch.Draw(SpriteCharBoxImage, pos, Color.White);                 
                    int resX;
                    for (int y = 0; y < 4; y++)
                    {
                        int y1 = (42 + (x * 130)) + 5 + (y * 25);
                        theText = "";
                        switch (y)
                        {
                            case 1: theText = "HP "; break; // + Convert.ToString(myChar[x].HP) + " / " + Convert.ToString(myChar[x].MaxHp);
                            case 2: theText = "MP "; break; // + Convert.ToString(myChar[x].MP) + " / " + Convert.ToString(myChar[x].MaxMP);
                            case 3: theText = "XP "; break; // + Convert.ToString(myChar[x].XP);
                        }
                        spriteBatch.DrawString(font, theText, new Vector2(1055, y1), Color.Black);

                        switch (y)
                        {
                            case 0: theText = myChar[x].name; break;
                            case 1: theText = Convert.ToString(myChar[x].HP) + " / " + Convert.ToString(myChar[x].MaxHP); break;
                            case 2: theText = Convert.ToString(myChar[x].MP) + " / " + Convert.ToString(myChar[x].MaxMP); break;
                            case 3: theText = Convert.ToString(myChar[x].XP); break;
                        }
                        resultLength = font.MeasureString(theText);
                        resX = (int)resultLength.X;
                        if (y == 0)
                            x1 = (int)Math.Floor((160 - resX) / 2) + 1050;
                        else
                            x1 = 1212 - resX;
                        spriteBatch.DrawString(font, theText, new Vector2(x1, y1), Color.Black);
                    }
                }
            }
        }

        public void DrawRectangle(int x1, int y1, int x2, int y2)
        {
            int x3 = x2 - x1;
            int y3 = y2 - y1;
            Vector2 pos = new Vector2(x1, y1);
            for (int x = 0; x < x3; x++)
            {
                for (int y = 0; y < y3; y++)
                {
                    pos.X = pos.X + x;
                    pos.Y = pos.Y + y;
                    spriteBatch.Draw(SpriteBlue, pos, Color.White);
                    pos.X = x1;
                    pos.Y = y1;
                }
            }
            DrawRectangleOutline(x1, y1, x2, y2);
        }

        public void DrawRectangleOutline(int x1, int y1, int x2, int y2)
        {
            DrawLineHoriz(x1, y1, x2, 3);
            DrawLineHoriz(x1, y2, x2, 3);
            DrawLineVert(x1, y1, y2, 3);
            DrawLineVert(x2, y1, y2, 3);
        }

        public void DrawLineHoriz(int x1, int y1, int x2, int width)
        {
            Vector2 pos = new Vector2(x1, y1);
            int x3 = x2 - x1;
            for (int a = 0; a < width; a++)
            {
                for (int x = 0; x < x3; x++)
                {
                    //pos.X = pos.X + x;
                    spriteBatch.Draw(SpriteBlack, pos, Color.White);
                    pos.X++;
                    //pos.X = x1;
                }
                pos.X = x1;
                pos.Y++;
            }
        }

        public void DrawLineVert(int x1, int y1, int y2, int width)
        {
            Vector2 pos = new Vector2(x1, y1);
            int y3 = y2 - y1;
            for (int a = 0; a < width; a++)
            {
                for (int y = 0; y < y3; y++)
                {
                    //pos.X = pos.X + x;
                    spriteBatch.Draw(SpriteBlack, pos, Color.White);
                    pos.Y++;
                    //pos.X = x1;
                }
                pos.Y = y1;
                pos.X++;
            }
        }

        public string DetermineString(int x)
        {
            switch (x)
            {
                case 1: return "As for retail games, everyone with a 360 should get Earth Defense Force. It's dirt cheap and though it's low budget and not very polished, it's also one of the funnest games I've played in years. I mean, the game starts you out with fighting giant space ants with an unlimited ammo rocket launcher in the first level and it only goes up from there. 100+ weapons to collect each with their own stats & quirks gives it a nice RPG-esque quality as well as you keep playing to see what cool new stuff you'll get.";
                case 2: return "Also, since this is also the catchall XBLA thread - anyone else have the N+ level pack and want to share in some bitching about some of the new co-op maps? I worked through the first half with a friend who did the original set with me, and there's been a couple so far that are even worse than those... first one that requires perfectly timed jumps between the two of you was entertaining with lag, but then we hit the ab";
                case 3: return "You pressed A!";
                case 4: return "You pressed X!";
                case 5: return "You pressed Y!";
                default: return "";
            }
        }

        public void DrawMenu()
        {
            Vector2 pos = new Vector2(140,455);
            spriteBatch.Draw(SpriteMenuBoxImage, pos, Color.White);
            if (myTextBox.pressA == 0 && mySys.pressA == 0)
            {
                for (int x = myMenu.topChoice; x < (myMenu.topChoice + 7); x++)  //myMenu.topChoice
                {
                    for (int y = 0; y < 3; y++)
                    {
                        if (myMenu.choices[x, y] != "")
                            spriteBatch.DrawString(font, myMenu.choices[x, y], new Vector2(160 + (y * 110), 470 + (x * 35)), Color.Black);
                    }
                }
                spriteBatch.Draw(SpriteMenuSelectSImage, new Vector2(146 + (myMenu.current[1] * 110), 468 + (myMenu.current[0] * 35)), Color.White);
            }
            else
            {
                spriteBatch.DrawString(font, "Press A to continue.", new Vector2(160, 470), Color.Black);
            }
        }

        public void DrawTextBox()
        {
            int drawLine;
            //DrawRectangle(myTextBox.myX1, myTextBox.myY1,myTextBox.myX2, myTextBox.myY2);
            Vector2 pos = new Vector2(40, 25);
            spriteBatch.Draw(SpriteTextBoxImage, pos, Color.White);
            if (myMenu.choicesDesc[0, 0, 0] != "")
            {
                myTextBox.ResetBox();
                myTextBox.Change(myMenu.choicesDesc[myMenu.current[0], myMenu.current[1], 0], myMenu.choicesDesc[myMenu.current[0], myMenu.current[1], 1], myMenu.choicesDesc[myMenu.current[0], myMenu.current[1], 2], myMenu.choicesDesc[myMenu.current[0], myMenu.current[1], 3]);
                FitBoxReal();
            }
            drawLine = 0;
            if (mySys.mode == 2)
            {
                DrawCharStats(0);
            }
            else
            {
                for (int x = myTextBox.startLine; x < (myTextBox.startLine + myTextBox.maxLines); x++)
                {
                    spriteBatch.DrawString(font, myTextBox.line[x], new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 5 + (drawLine * 25)), Color.Black);
                    drawLine++;
                }
                if (myTextBox.line[myTextBox.startLine + myTextBox.maxLines] != "")
                {
                    myTextBox.pressA = 1;
                }
                else
                {
                    myTextBox.pressA = 0;
                }
            }
        }

        public void DrawCharStats(int wC) //which char
        {
            //wC = myquest.charSpot[wC]; 
            spriteBatch.DrawString(font, myChar[wC].name, new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 5), Color.Black);
            spriteBatch.DrawString(font, myChar[wC].jobName[0] + " LV " + System.Convert.ToString(myChar[wC].jobLV[0]) + ", " + myChar[wC].jobName[1] + " LV " + System.Convert.ToString(myChar[wC].jobLV[1]) + ", " + myChar[wC].jobName[2] + " LV " + System.Convert.ToString(myChar[wC].jobLV[2]), new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 30), Color.Black);
            spriteBatch.DrawString(font, "Strength = " + System.Convert.ToString(myChar[wC].Str) + ", " + "Magic = " + System.Convert.ToString(myChar[wC].Mag), new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 55), Color.Black);
            spriteBatch.DrawString(font, "Defense = " + System.Convert.ToString(myChar[wC].Def) + ", " + "Magic Defense = " + System.Convert.ToString(myChar[wC].MDef), new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 80), Color.Black);
            spriteBatch.DrawString(font, "Learning = " + System.Convert.ToString(myChar[wC].Learn) + ", " + "Style = " + System.Convert.ToString(myChar[wC].Style), new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 105), Color.Black);
            spriteBatch.DrawString(font, "Agility = " + System.Convert.ToString(myChar[wC].Agi), new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 130), Color.Black);
            spriteBatch.DrawString(font, "Fire = " + System.Convert.ToString(myChar[wC].fireRes) + "%" + ", " + "Cold = " + System.Convert.ToString(myChar[wC].coldRes) + "%", new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 155), Color.Black);
            spriteBatch.DrawString(font, "Air = " + System.Convert.ToString(myChar[wC].airRes) + "%" + ", " + "Earth = " + System.Convert.ToString(myChar[wC].earthRes) + "%", new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 180), Color.Black);
            spriteBatch.DrawString(font, "Special = Immune to stun & curses.", new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 205), Color.Black);
            spriteBatch.DrawString(font, "Books = None", new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 230), Color.Black);
            spriteBatch.DrawString(font, "Accessories = None", new Vector2(myTextBox.myX1 + 5, myTextBox.myY1 + 255), Color.Black);
        }

        public void TextSet(int a, int b)
        {
            myTextBox.Determine(a, b);
            FitBoxReal();
        }

        public void FitBoxReal() //a is the total text
        {
            //int whichText; //which array of text do we check?
            //whichText = myTextBox.startText;
            double mxLines;

            for (int x = 0; x < 100; x++)
            {
                myTextBox.line[x] = "";
            }
            int finished; //are we finished with this block of text?
            finished = 0;
            int currentLine = 0;  //which Line are we working on right now?
            int currentSpot = 0;  //which spot are we on?
            currentSpot = myTextBox.endSpot;
            mxLines =  Math.Floor((myTextBox.myY2 - myTextBox.myY1 - 10) / 25);
            myTextBox.maxLines = System.Convert.ToInt16(mxLines);
            int maxLength = myTextBox.myX2 - myTextBox.myX1 - 15;  //maxLength a string can be on this line
            Vector2 resultLength;
            //myTextBox.maxLines = 20;

            for (int bigpic = 0; bigpic < 8; bigpic++)  //myTextBox.endText
            {
                if (myTextBox.text[bigpic] == "")
                    break;
                //Let's separate the text
                String[] arr = new string[myTextBox.text[bigpic].Length];
                for (int x = myTextBox.endSpot; x < myTextBox.text[bigpic].Length; x++)  // x = 0
                {
                    arr[x] = myTextBox.text[bigpic].Substring(x, 1);
                }
                //done separating
                String result = "";
                // int maxLength = myTextBox.myX2 - myTextBox.myX1 - 15;  //maxLength a string can be on this line
                // int startingPos; int endingPos; 
                int lastSpace;
                lastSpace = 0;

                //the actual sorting
                finished = 0;
                int resX;
                while (finished == 0)
                {
                    result = "";
                    resultLength = font.MeasureString(result);
                    resX = 0; //the current length of the temp text
                    for (int x = currentSpot; x < myTextBox.text[bigpic].Length; x++)
                    {
                        if (arr[x] == " ")
                        {
                            lastSpace = x;
                        }
                        result = result + arr[x];
                        resultLength = font.MeasureString(result);
                        resX = (int)resultLength.X;
                        if (resX > maxLength)
                        {
                            break;
                        }
                        if (x == myTextBox.text[bigpic].Length - 1)
                        {
                            finished = 1;
                            lastSpace = myTextBox.text[bigpic].Length;
                            break;
                        }
                    }
                    result = "";
                    for (int x = currentSpot; x < lastSpace; x++) // lastSpace --> 10, currentSpot --->0
                    {
                        result = result + arr[x];
                    }
                    myTextBox.line[currentLine] = result; //currentLine --->0

                    if (finished == 1)  //done with that text
                    {
                        lastSpace = myTextBox.text[bigpic].Length;
                        if (currentLine == (myTextBox.maxLines - 1) || currentLine == ((myTextBox.maxLines * 2) - 1) || currentLine == ((myTextBox.maxLines * 3) - 1) || currentLine == ((myTextBox.maxLines * 4) - 1) || currentLine == ((myTextBox.maxLines * 5) - 1))
                            currentLine++;
                        else
                            currentLine = currentLine + 2;
                        currentSpot = 0;
                    }
                    else  //not done with that text
                    {
                        currentSpot = lastSpace + 1;
                        currentLine++;
                    }
                } //end sorting
            }  //end big picture
        }
        public void charMenuSetUp(int thetype){
            for (int x = 0; x < 5; x++)
            {
                switch (thetype)
                {
                    case 1: myMenu.choices[x,0] = myChar[myquest.charSpot[x] ].name; //all allies
                        break;
                    case 2: if (myChar[myquest.charSpot[x]].HP != 0)  //all allies with HP>0
                            myMenu.choices[x,0] = myChar[myquest.charSpot[x]].name;
                        break;
                    case 3: if (myChar[myquest.charSpot[x]].HP == 0)  //all allies with HP=0
                            myMenu.choices[x,0] = myChar[myquest.charSpot[x]].name;
                        break;
                    case 4: //all enemies
                        break;
                    case 5: //front row enemies
                        break;
                    case 6: // 
                        break;
                }
            }

            switch (thetype){
                case 1: //all allies
                    for (int x = 0; x < 5; x++)
                    {
                        myMenu.choices[x,0] = myChar[myquest.charSpot[x]].name;
                    }
                    break;
                case 2: //all allies with HP>0
                    for (int x = 0; x < 5; x++)
                    {
                        if (myChar[myquest.charSpot[x]].HP != 0)
                            myMenu.choices[x,0] = myChar[myquest.charSpot[x]].name;
                    }
                    break;
                case 3:
                default:
                    break;
            }
        }

        //public string FitBox(string s4) //a is the total text
        //{
        //   String[] arr = new string[s4.Length];
        //   for (int x = 0; x < s4.Length; x++)  //Let's separate the text
        //    {
        //        arr[x] = s4.Substring(x, 1);
        //    }
        //    String result = "";
        //    //int x1 = 0;
        //    int x2 = 0;
        //    Vector2 resultLength = font.MeasureString(result);
        //    for (int x = 0; x < s4.Length; x++)
        //    {
        //        result = result + arr[x];
        //        resultLength = font.MeasureString(result);
        //        x2 = (int)resultLength.X;
        //        if (x2 > 1200)
        //        {
        //            break;
        //        }
        //   }
        //    return result;
            //Vector2 fontOrigin = font.MeasureString(arr);
        //}
    }
}
