using System;
using System.Collections.Generic;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Menu
    {
        public int x1, y1, size;
        public int type; //0=regular,
        public int[] current; //where's the cursor at? current[0] = up/down, current[1] = left/right
        public int topChoice, bottomChoice;
        public string[,] choices;
        public string myChoice;
        public int myChoiceVar;
        public string[,,] choicesDesc;  //[x,y,z] x = Up/Down Choice, y=Left/Right Choice, Z = Text

        public void Determine(int mode, int page)
        {
            Reset();
            switch (mode)
            {
                case 0: switch (page)
                    {
                        case 0: UpDown("Start", "Continue", "Analyze", "Quit");
                            break;
                        default: break;
                    }
                    break;
                case 1: UpDown("Story", "Arena", "Save", "Exit");
                    break;
                default: break;
            }
            DetermineDesc(mode);
        }

        public void DetermineDesc(int mode)
        {
            switch (mode)
            {
                case 1: SetDesc(0, "Play through an exciting chapter in the book of Molly!", "You have completed 5/14 chapters.");
                    SetDesc(1, "To unlock this mode, finish 2 more story chapters.");
                    SetDesc(2, "Saving not implemented yet.");
                    SetDesc(3, "Go back to the title screen.");
                    break;
            }
        }

        public void SetDesc(int a, int b, string s1, string s2, string s3, string s4)
        {
            choicesDesc[a, b, 0] = s1;
            choicesDesc[a, b, 1] = s2;
            choicesDesc[a, b, 2] = s3;
            choicesDesc[a, b, 3] = s4;
        }

        public void SetDesc(int a, int b, string s1, string s2, string s3)
        {
            choicesDesc[a, b, 0] = s1;
            choicesDesc[a, b, 1] = s2;
            choicesDesc[a, b, 2] = s3;
        }

        public void SetDesc(int a, int b, string s1, string s2)
        {
            choicesDesc[a, b, 0] = s1;
            choicesDesc[a, b, 1] = s2;
        }

        public void SetDesc(int a, int b, string s1)
        {
            choicesDesc[a, b, 0] = s1;
        }

        public void SetDesc(int a, string s1, string s2, string s3, string s4)
        {
            choicesDesc[a, 0, 0] = s1;
            choicesDesc[a, 0, 1] = s2;
            choicesDesc[a, 0, 2] = s3;
            choicesDesc[a, 0, 3] = s4;
        }

        public void SetDesc(int a, string s1, string s2, string s3)
        {
            choicesDesc[a, 0, 0] = s1;
            choicesDesc[a, 0, 1] = s2;
            choicesDesc[a, 0, 2] = s3;
        }

        public void SetDesc(int a, string s1, string s2)
        {
            choicesDesc[a, 0, 0] = s1;
            choicesDesc[a, 0, 1] = s2;
        }

        public void SetDesc(int a, string s1)
        {
            choicesDesc[a, 0, 0] = s1;
        }



        public void UpDown(string a, string b, string c, string d, string e, string f, string g)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
            choices[2, 0] = c;
            choices[3, 0] = d;
            choices[4, 0] = e;
            choices[5, 0] = f;
            choices[6, 0] = g;
        }

        public void UpDown(string a, string b, string c, string d, string e, string f)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
            choices[2, 0] = c;
            choices[3, 0] = d;
            choices[4, 0] = e;
            choices[5, 0] = f;
        }

        public void UpDown(string a, string b, string c, string d, string e)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
            choices[2, 0] = c;
            choices[3, 0] = d;
            choices[4, 0] = e;
        }

        public void UpDown(string a, string b, string c, string d)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
            choices[2, 0] = c;
            choices[3, 0] = d;
        }

        public void UpDown(string a, string b, string c)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
            choices[2, 0] = c;
        }

        public void UpDown(string a, string b)
        {
            choices[0, 0] = a;
            choices[1, 0] = b;
        }

        public void UpDown(string a)
        {
            choices[0, 0] = a;
        }

        public void MenuControl(string a) //a is the direction or button pressed.
        {
            switch (a)
            {
                case "Up": if (current[0] == 0)
                    {
                        current[0] = 99;
                        while (choices[ current[0], current[1] ] == "")
                        {
                            current[0]--;
                        }
                    }
                    else
                    {
                        current[0]--;
                    }
                    break;
                case "Down":
                    if (current[0] == 99)
                    {
                        current[0] = 0;
                    }
                    else
                    {
                        current[0]++;
                        if (choices[ current[0], current[1] ] == "")
                            current[0] = 0;
                    }
                    break;
                case "A": myChoice = choices[current[0], current[1]];
                    myChoiceVar = current[0];
                    break;
                case "B": myChoice = "Cancel";
                    break;
                case "X": myChoice = "X";
                    break;
                case "Y": myChoice = "Y";
                    break;
                default: break;
            }
        }

        public void Reset(){
            x1 = 0;
            y1 = 0;
            size = 0;
            current = new int[2];
            current[0] = 0;
            current[1] = 0;
            topChoice = 0;
            bottomChoice = 0;
            choices = new string[100, 3];
            choicesDesc = new string[100, 3, 4];
            type = 0;
            for (int x = 0; x < 100; x++)
            {
                for (int y = 0; y < 3; y++)
                {
                    choices[x, y] = "";
                }
            }
            for (int x = 0; x < 100; x++)
            {
                for (int y = 0; y < 3; y++)
                {
                    for (int z = 0; z < 4; z++)
                    {
                        choicesDesc[x, y, z] = "";
                    }
                }
            }
            myChoice = "";
            myChoiceVar = 0;
        }

        public Menu()
        {
            Reset();
        }
    }
}