using System;
using System.Collections.Generic;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Character
    {
        public string name;
        public int LV, Str, Mag, Agi, Vit, HP, MaxHP, MP, MaxMP;
        public int Def, MDef;
        public double EarthRes, FireRes, WaterRes, ElecRes, DarkRes, LightRes;  //1=Normal, 0 = Immune 2=Weak

        //Battle only variables
        public int Moved; //0 = Hasn't had a turn in battle yet, 1 = Has, 2 = Current Turn
        public int Defend; //0 = Normal, 1 = Choose defend command this turn
        public int Poison; //# = Damage per turn
        public int Charm, Stun, Blind, Sleep, Curse; // # = How many turns left
        public string[] EffectName; //name of special effects like Lupine Form
        public double[] EffectPower; //power of special effects like Endless Night
        public double StrKaja, MagKaja, AgiKaja, DefKaja, MDefKaja; //1 = Normal, 1.34 = Boost, .66 = Weak
        public int StrPower, MagPower, AgiPower, DefPower, MDefPower; //Power-up bonuses

        public Character()
        {
            name = "";
            LV = 0; Str = 0; Mag = 0; Agi = 0; Vit = 0; HP = 0; MaxHP = 0; MaxMP = 0; MP = 0;
            Def = 0; MDef = 0;
            StrKaja = 1; MagKaja = 1; AgiKaja = 1; DefKaja = 1; MDefKaja = 1;
            StrPower = 0; MagPower = 0; AgiPower = 0; DefPower = 0; MDefPower = 0;
            EarthRes = 1; FireRes = 1; WaterRes = 1; ElecRes = 1; DarkRes = 1; LightRes = 1;
            Moved = 0; Defend = 0; Poison = 0; Charm = 0; Stun = 0; Blind = 0; Sleep = 0; Curse = 0;
            EffectName = new string[4];
            EffectPower = new double[4];
            for (int x = 0; x < 4; x++)
            {
                EffectName[x] = "";
                EffectPower[x] = 0;
            }
        }
        /*public void letsTest()
        {
            name = "Molly";
            HP = 350; MaxHP = 400; MP = 100; MaxMP = 150;
            XP = 5;
        }*/

        public void InitiateChar(string theName, int theLV)
        {
            name = theName;
            LV = theLV;
            double LVMultiplier;
            LVMultiplier = 1 + (0.2 * LV);
            switch (name)
            {
                case "Molly":
                    MaxHP = 30; MaxMP = 6; Str = 9; Mag = 7; Agi = 7; Def = 5; MDef = 4;
                    EarthRes = 0.5; LightRes = 0.5;
                    break;
                case "Umiko":
                    MaxHP = 22; MaxMP = 9; Str = 8; Mag = 5; Agi = 9; Def = 4; MDef = 2;
                    WaterRes = 0.5; FireRes = 0.5; ElecRes = 2;
                    break;
                case "Torment":
                    MaxHP = 16; MaxMP = 15; Str = 4; Mag = 9; Agi = 5; Def = 2; MDef = 5;
                    DarkRes = 0.5; LightRes = 2;
                    break;
                case "Sleet":
                    MaxHP = 24; MaxMP = 12; Str = 7; Mag = 7; Agi = 6; Def = 3; MDef = 3;
                    ElecRes = 0.5; WaterRes = 2;
                    break;
            }
            MaxHP = (int)Math.Floor(MaxHP * LVMultiplier);
            MaxMP = (int)Math.Floor(MaxMP * LVMultiplier);
            Str = (int)Math.Floor(Str * LVMultiplier);
            Mag = (int)Math.Floor(Mag * LVMultiplier);
            Agi = (int)Math.Floor(Agi * LVMultiplier);
            Def = (int)Math.Floor(Def * LVMultiplier);
            MDef = (int)Math.Floor(MDef * LVMultiplier);

            //InitiateStats();
            HP = MaxHP;
            MP = MaxMP;
        }

        public int TrueStrength()
        {
            int x;
            x = Str + StrPower;
            x = (int)Math.Floor(x * StrKaja);
            if (EffectName[0] == "Fan")
            {
                x = (int)Math.Floor(x * 1.25);
            }
            return x;
        }

        public int TrueMagic()
        {
            int x;
            x = Mag + MagPower;
            x = (int)Math.Floor(x * MagKaja);
            if (EffectName[0] == "Fan")
            {
                x = (int)Math.Floor(x * 1.25);
            }
            return x;
        }

        public int TrueAgi()
        {
            int x;
            x = Agi + AgiPower;
            x = (int)Math.Floor(x * AgiKaja);
            if (EffectName[0] == "Fan")
            {
                x = (int)Math.Floor(x * 1.25);
            }
            return x;
        }

        public int TrueDef()
        {
            int x;
            x = Def + DefPower;
            x = (int)Math.Floor(x * DefKaja);
            if (EffectName[0] == "Fan")
            {
                x = (int)Math.Floor(x * 1.25);
            }
            return x;
        }

        public int TrueMDef()
        {
            int x;
            x = MDef + MDefPower;
            x = (int)Math.Floor(x * MDefKaja);
            if (EffectName[0] == "Fan")
            {
                x = (int)Math.Floor(x * 1.25);
            }
            return x;
        }

        public void LoseHP(int loss)
        {
            if (loss > HP)
            {
                HP = 0;
            }
            else
            {
                HP = HP - loss;
            }
        }
        public void GainHP(int gain)
        {
            HP = HP + gain;
            if (HP > MaxHP)
                HP = MaxHP;
        }

        public void GainMP(int gain)
        {
            MP = MP + gain;
            if (MP > MaxMP)
                MP = MaxMP;
        }

        public void LoseMP(int loss)
        {
            if (loss > MP)
            {
                MP = 0;
            }
            else
            {
                MP = MP - loss;
            }
        }


        /*public void InitiateStats()
        {
            int numJobs;
            if (jobLV[2] == 0)
                numJobs = 2;
            else
                numJobs = 3;

            double[] balance = new double[3];
            for (int x = 0; x < 3; x++)
            {
                balance[x] = 0.5;
            }

            switch (numJobs) //determine the weight to give each job's stats
            {
                case 2:
                    if (jobLV[0] == jobLV[1])
                    {
                        balance[0] = 0.75;
                        balance[1] = 0.75;
                    }
                    if (jobLV[0] > jobLV[1])
                        balance[0] = 1;
                    if (jobLV[1] > jobLV[0])
                        balance[1] = 1;
                    break;
                case 3:
                    if (jobLV[0] == jobLV[1] & jobLV[0] == jobLV[2])
                    {
                        balance[0] = 0.67;
                        balance[1] = 0.67;
                        balance[2] = 0.67;
                    }
                        if (jobLV[0] == jobLV[1] & jobLV[0] > jobLV[2])
                        {
                            balance[0] = 0.75;
                            balance[1] = 0.75;
                        }
                        if (jobLV[0] == jobLV[2] & jobLV[0] > jobLV[1])
                        {
                            balance[0] = 0.75;
                            balance[1] = 0.75;
                        }
                        if (jobLV[1] == jobLV[2] & jobLV[1] > jobLV[0])
                        {
                            balance[1] = 0.75;
                            balance[2] = 0.75;
                        }
                        if (balance[0] == 0.5 & balance[1] == 0.5 & balance[2] == 0.5)
                        {
                            if (jobLV[0] > jobLV[1] & jobLV[0] > jobLV[2])
                                balance[0] = 1;
                            if (jobLV[1] > jobLV[0] & jobLV[1] > jobLV[2])
                                balance[1] = 1;
                            if (jobLV[2] > jobLV[0] & jobLV[2] > jobLV[0])
                                balance[2] = 1;
                        }
                    break;
            }
            //test
            //balance[1] = 1; balance[0] = 1; balance[2] = 1;

            jobMaxHP[3] = 0; jobMaxMP[3] = 0; jobStr[3] = 0; jobMag[3] = 0; jobDef[3] = 0; jobMDef[3] = 0; jobLearn[3] = 0; jobStyle[3] = 0; jobAgi[3] = 0;
            for (int x = 0; x<numJobs; x++){
                jobMaxHP[3] = jobMaxHP[3] + (jobLV[x] * jobMaxHP[x] * balance[x]);
                jobMaxMP[3] = jobMaxMP[3] + (jobLV[x] * jobMaxMP[x] * balance[x]);
                jobStr[3] = jobStr[3] + (jobLV[x] * jobStr[x] * balance[x]);
                jobMag[3] = jobMag[3] + (jobLV[x] * jobMag[x] * balance[x]);
                jobDef[3] = jobDef[3] + (jobLV[x] * jobDef[x] * balance[x]);
                jobMDef[3] = jobMDef[3] + (jobLV[x] * jobMDef[x] * balance[x]);
                jobLearn[3] = jobLearn[3] + (jobLV[x] * jobLearn[x] * balance[x]);
                jobStyle[3] = jobStyle[3] + (jobLV[x] * jobStyle[x] * balance[x]);
                jobAgi[3] = jobAgi[3] + (jobLV[x] * jobAgi[x] * balance[x]);
            }
            MaxHP = System.Convert.ToInt32(Math.Floor(jobMaxHP[3]));
            MaxMP = System.Convert.ToInt32(Math.Floor(jobMaxMP[3]));
            Str = System.Convert.ToInt32(Math.Floor(jobStr[3]));
            Mag = System.Convert.ToInt32(Math.Floor(jobMag[3]));
            Def = System.Convert.ToInt32(Math.Floor(jobDef[3]));
            MDef = System.Convert.ToInt32(Math.Floor(jobMDef[3]));
            Learn = System.Convert.ToInt32(Math.Floor(jobLearn[3]));
            Style = System.Convert.ToInt32(Math.Floor(jobStyle[3]));
            Agi = System.Convert.ToInt32(Math.Floor(jobAgi[3]));
        }
        */
        public void Reset()
        {
            name = "";
        }
    }
}

/*public string name;
public int[] jobLV;  //[3]
public int currentJob;
public string[] jobName; //[3]
public int MaxHP, HP, MaxMP, MP;
public int Str, Mag, Agi, Def, MDef, Learn, Style;
public double[] jobStr, jobMag, jobAgi, jobDef, jobMDef, jobLearn, jobStyle, jobMaxHP, jobMaxMP;
public int XP;
public string[] acc; //what accessories are equipped 3
public string[] guide; //3
public int accMax, guideMax; //how many accessories & guides can be equipped
public string race; //Living, Undead, Mech
public int fireRes, coldRes, earthRes, airRes;
 */
//public int[] weaponDam; //3 array
//public int[] weaponType; //0 = Str-based, 1=Mag-based, 2=flat  3 in array
//public string weaponName;