using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Monster
    {
        public string name;
        public string the, The;
        public int LV, Str, Mag, Agi, Vit, HP, MaxHP, MP, MaxMP;
        public int Def, MDef;
        public double EarthRes, FireRes, WaterRes, ElecRes, DarkRes, LightRes;  //1=Normal, 0 = Immune 2=Weak
        public int CharmRes, StunRes, SleepRes, PoisonRes; // 0 = Immune, 1 = Weak
        //public int[] AIChance; // array 3 <x = %chance of occuring.  Attack if nothing processes
        public string[] AIName; //
        public int[] AIPower;
        public int NumberAI;
        //public string[] AITrigger; // array 3 = What condition triggers the effect
        //public int[] AITriggerChance; // x=%chance of occuring.  100 if the trigger definitely triggers it.
        //public string[] AITriggerName; //Trigger spell name

        //Battle only variables
        public int Moved; //0 = Hasn't had a turn in battle yet, 1 = Has, 2 = Current Turn
        public int Defend; //0 = Normal, 1 = Choose defend command this turn
        public int Poison; //# = Damage per turn
        public int Charm, Stun, Blind, Sleep, Curse; // # = How many turns left
        //public string[] EffectName; //name of special effects like Lupine Form
        //public int[] EffectPower; //power of special effects like Endless Night
        public double StrKaja, MagKaja, AgiKaja, DefKaja, MDefKaja; //1 = Normal, 1.34 = Boost, .66 = Weak
        //public int StrPower, MagPower, AgiPower, DefPower, MDefPower; //Power-up bonuses

        public Monster()
        {
            Reset();
        }
        public void Reset()
        {
            name = "";
            the = "";
            The = "";

            LV = 0; Str = 0; Mag = 0; Agi = 0; Vit = 0; HP = 0; MaxHP = 0; MaxMP = 0; MP = 0;
            Def = 0; MDef = 0;
            StrKaja = 1; MagKaja = 1; AgiKaja = 1; DefKaja = 1; MDefKaja = 1;
            //StrPower = 0; MagPower = 0; AgiPower = 0; VitPower = 0;
            EarthRes = 1; FireRes = 1; WaterRes = 1; ElecRes = 1; DarkRes = 1; LightRes = 1;
            CharmRes = 1; StunRes = 1; SleepRes = 1; PoisonRes = 1;

            Moved = 0; Defend = 0; Poison = 0; Charm = 0; Stun = 0; Blind = 0; Sleep = 0; Curse = 0;
            AIName = new string[3];
            AIPower = new int[3];
            NumberAI = 1;

            for (int x = 0; x < 3; x++)
            {
                //EffectName[x] = "";
                //EffectPower[x] = 0;
                //AIChance[x] = 0;
                AIName[x] = "";
                AIPower[x] = 0;
                //AITrigger[x] = "";
                //AITriggerChance[x] = 0;
                //AITriggerName[x] = "";
            }
        }

        public void Proper(bool prop)
        {
            if (prop)
            {
                the = name;
                The = name;
            }
            else
            {
                the = "the " + name;
                The = "The " + name;
            }
        }

        public void LoseHP(int loss)
        {
            if (loss > HP)
            {
                HP = 0;
            }
            else
            {
                HP = HP - loss;
            }
        }

        public void LoseMP(int loss)
        {
            if (loss > MP)
            {
                MP = 0;
            }
            else
            {
                MP = MP - loss;
            }
        }

        public void GainHP(int gain)
        {
            HP = HP + gain;
            if (HP > MaxHP)
                HP = MaxHP;
        }

        public void GainMP(int gain)
        {
            MP = MP + gain;
            if (MP > MaxMP)
                MP = MaxMP;
        }

        public int TrueStrength()
        {
            int x;
            x = (int)Math.Floor(Str * StrKaja);
            return x;
        }

        public int TrueMagic()
        {
            int x;
            x = (int)Math.Floor(Mag * MagKaja);
            return x;
        }

        public int TrueAgi()
        {
            int x;
            x = (int)Math.Floor(Agi * AgiKaja);
            return x;
        }

        public int TrueDef()
        {
            int x;
            x = (int)Math.Floor(Def * DefKaja);
            return x;
        }

        public int TrueMDef()
        {
            int x;
            x = (int)Math.Floor(MDef * MDefKaja);
            return x;
        }

        public void CreateMonster(string whichMonster)
        {
            Reset();
            AIName[0] = "Attack";
            name = whichMonster;
            switch (whichMonster)
            {
                case "Bandit": MaxHP = 25;
                    Def = 1;
                    MDef = 0;
                    Agi = 4;
                    Str = 11;
                    Mag = 1;
                    Proper(false);
                    break;
                default: break;
                case "Berserker": MaxHP = 45;
                    Def = 3;
                    MDef = 1;
                    Agi = 6;
                    Str = 15;
                    Mag = 2;
                    AIName[1] = "Wild Attack";
                    AIPower[1] = 25;
                    NumberAI = 2;
                    DarkRes = 2;
                    Proper(false);
                    break;
                case "Hedge Mage": MaxHP = 15;
                    Def = 0;
                    MDef = 5;
                    Agi = 7;
                    Str = 10;
                    Mag = 12;
                    AIName[0] = "Fireball";
                    AIPower[0] = 12;
                    FireRes = 0.5;
                    StunRes = 0;
                    Proper(false);
                    break;
                case "Bandit Chief": MaxHP = 80;
                    Def = 4;
                    MDef = 2;
                    Agi = 3;
                    Str = 20;
                    Mag = 4;
                    DarkRes = 2;
                    Proper(false);
                    //the = "the Bandit Chiefie";
                    //The = "The Bandit Chiefie";
                    break;
                case "Punching Bag": MaxHP = 10000;
                    Def = 0;
                    MDef = 0;
                    Agi = 1;
                    Str = 0;
                    Mag = 0;
                    Proper(false);
                    break;
            }
            HP = MaxHP;
        }

    }
}